<?php
/**
* phpmyfaqTemplate
*
* The phpmyfaqTemplate class provides methods and functions for the
* template parser
*
* @author       Thorsten Rinne <thorsten@phpmyfaq.de>
* @package      phpmyfaqTemplate
* @since        2002-08-22
* @version      2004-07-07
*
* Copyright:    (c) 2002-2004 Thorsten Rinne
*
* The contents of this file are subject to the Mozilla Public License
* Version 1.1 (the "License"); you may not use this file except in
* compliance with the License. You may obtain a copy of the License at
* http://www.mozilla.org/MPL/
*
* Software distributed under the License is distributed on an "AS IS"
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
* License for the specific language governing rights and limitations
* under the License.
*/

class phpmyfaqTemplate
{
	var $templates = array();
	var $outputs = array();
	
	function phpmyfaqTemplate($myTemplate)
    {
		while (list($templateName, $filename) = each($myTemplate)) {
			$this->templates[$templateName] = $this->readTemplate($filename);
			}
	}
	
    function includeTemplate($name, $toname)
    {
	 	$this->outputs[$toname] = str_replace('{'.$name.'}', $this->outputs[$name], $this->outputs[$toname]);
		$this->outputs[$name] = '';
	}
	
	function processTemplate($templateName, $myTemplate)
    {
		$tmp = $this->templates[$templateName];
		while (list($var, $val) = each($myTemplate)) {
			$tmp = str_replace('{'.$var.'}', $val, $tmp);
			}
		if (isset($this->outputs[$templateName])) {
			$this->outputs[$templateName] .= $tmp;
			}
		else {
			$this->outputs[$templateName] = $tmp;
			}
    }
	
	function printTemplate()
    {
		while(list( , $val) = each($this->outputs)) {
			print str_replace("\n\n", "\n", $val);
			}
	}
	
	function addTemplate($name, $toname)
    {
		$this->outputs[$toname] .= $this->outputs[$name];
		$this->outputs[$name] = '';
	}
	
	function readTemplate($filename)
    {
		if (file_exists($filename)) {
			$res = implode("\n", file($filename));
			return $res;
		    }
		print "<p><span style=\"color: red;\">Error:</span> Cannot open the file ".$filename.".</p>";
		die();
	}
}
?>